function [f,g] = LL_hmxlfse(INPUT,err_sliced,EstimOpt,B)

% save tmp_LL_hmxl
% return

Y1 = INPUT.YY1;
Xa1 = INPUT.XXa1;
Y2 = INPUT.YY2;
Xa2r = INPUT.XXa2r;
Xa2f = INPUT.XXa2f;
Xstr = INPUT.Xstr;


NAlt1 = EstimOpt.NAlt1; 
NCT1 = EstimOpt.NCT1; 
NP = EstimOpt.NP;
NVarA1 = EstimOpt.NVarA1; 
NVarRnd1 = EstimOpt.NVarRnd1; 
NAlt2 = EstimOpt.NAlt2; 
NVarStr = EstimOpt.NVarStr; 

NCT2 = EstimOpt.NCT2; 
NVarA2 = EstimOpt.NVarA2;
NVarRnd2 = EstimOpt.NVarRnd2; 
NRep = EstimOpt.NRep;
Dist1 = EstimOpt.Dist1;
Dist2 = EstimOpt.Dist2;
FullCov = EstimOpt.FullCov;
RealMin = EstimOpt.RealMin;
InterEffects = EstimOpt.InterEffects;
CutOff = EstimOpt.CutOff;
FSEMat = EstimOpt.FSEMat;
Type = EstimOpt.Type;

ba1 = B(1:NVarA1); % b atrybutw
if FullCov == 0
    bv1 = B(NVarA1+1:NVarA1+NVarRnd1);
    VC1 = diag(bv1);
    l = NVarA1+NVarRnd1;
elseif FullCov == 1 || FullCov == 2
    bv1 = B(NVarA1+1:NVarA1+sum(1:NVarRnd1));
    VC1 = tril(ones(NVarRnd1));
    VC1(VC1 == 1) = bv1;
    l = NVarA1+sum(1:NVarRnd1);
end
ba2 = B(l+1:l+NVarA2); % b atrybutw
if FullCov < 2
    bv2 = B(l+NVarA2+1:l+NVarA2+NVarRnd2);
    VC2 = diag(bv2);
    l = l+NVarA2+NVarRnd2;
else
    bv2 = B(l+NVarA2+1:l+NVarA2+sum(1:NVarRnd2));
    VC2 = tril(ones(NVarRnd2));
    VC2(VC2 == 1) = bv2;
    l = l+NVarA2+sum(1:NVarRnd2);
end
if NVarStr > 0
    bstr = reshape(B(l+1:l+NVarRnd2*NVarStr),[NVarStr, NVarRnd2]);
    l = l+NVarRnd2*NVarStr;
end
binter = B(l+1:l+InterEffects);
bcutoff = B(l+InterEffects+1:end);

if Type == 0
    Sig = exp(bcutoff);
    Thres = [];
elseif Type == 1
    Thres = bcutoff;
    Thres(2:end) = exp(Thres(2:end));
    Thres(2:end) = cumsum(Thres(2:end)); 
    Thres = [-inf; Thres; inf];
end
b_mtx2 = ba2(Dist2 ~= -1) + VC2*err_sliced(NVarRnd1+1:end,:); % NVarRnd2 x NRep*NP
if NVarStr > 0
    Fit_str = reshape(Xstr*bstr, [NP, 1, NVarRnd2]); % NVarRnd2 x NP 
    Fit_str = reshape(Fit_str(:, ones(1, NRep),:), [NP*NRep, NVarRnd2])';
    b_mtx2 = b_mtx2 + Fit_str;
end
b_mtx1 = ba1(:, ones(1, NRep*NP));
b_mtx1(Dist1 ~= -1,:) = b_mtx1(Dist1 ~= -1,:) + VC1*err_sliced(1:NVarRnd1,:); % NVarA x NRep*NP  
l = 0;
for i = 1:NVarA1
    if any(FSEMat(:,i) == 1)
        b_mtx1(i,:) = b_mtx1(i,:) + sum(b_mtx2(FSEMat(:,i) == 1,:).*binter(l+1:l+sum(FSEMat(:,i) == 1)),1);
        l = l+sum(FSEMat(:,i) == 1);
    end
end

if sum(Dist1 == 1) > 0 % Log - normal
    b_mtx1(Dist1(Dist1 ~= -1) == 1,:) = exp(b_mtx1(Dist1(Dist1 ~= -1) == 1,:));
end

b_mtx1 = reshape(b_mtx1,[NVarA1,NRep,NP]); % NVarA x NRep x NP
b_mtx2 = reshape(b_mtx2,[NVarRnd2,NRep,NP]); % NVarA x NRep x NP

Xa2_fit =  reshape(Xa2f*ba2(Dist2 == -1),[NCT2, NP]);
probs = zeros(NP,1);

if nargout == 1 % function value only
    parfor n = 1:NP
        Yy_n = Y1(:,n) == 1;
        Xa_n = Xa1(:,:,n);
        U = reshape(Xa_n*b_mtx1(:,:,n),[NAlt1,NCT1,NRep]);
        U = exp(U - max(U)); % rescale utility to avoid exploding
        U_sum = reshape(sum(U,1),[NCT1,NRep]);
        U_selected = reshape(U(Yy_n(:,ones(NRep,1))),[NCT1,NRep]);   
        U_prod = prod(U_selected./U_sum,1); % 1 x NRep
        
        % Second equation
        Xa2_n = Xa2r(:,:,n);
        Yy_n = Y2(:,n);
        Fit_n = Xa2_n*b_mtx2(:,:,n) + Xa2_fit(:,n); % NCT2 x NRep  
        if Type == 0
            p2 = normpdf(Yy_n,Fit_n, Sig);
        elseif Type == 1
            % Yy_n przyjmuje wartosci 1-11, Thres ma dlugosc 12 
            p2 = normcdf(Thres(Yy_n+1)-Fit_n) - normcdf(Thres(Yy_n)-Fit_n);
        end
        p2 = prod(p2,1); % 1 x NRep
        probs(n) = mean(U_prod.*p2,2);
    end


    if RealMin == 0
        f = -log(probs);
    else
        f = -log(max(realmin,probs));
    end
else % function value + gradient
 
end
